<template>
  <div v-if="appVariant === 'aleph'"
    class="flex gap-4 pb-4 !w-full"
  >
    <svn-dialog-import-profile-photo
      v-if="edit"
      ref="dialog"
      :dialog-custom-class="dialogCustomClass"
      @upload-file="uploadFile"
      @delete-picture="deletePicture"
    >
      <template #activator>
        <div class="flex justify-center items-center">
          <div class="group cursor-pointer relative">
            <svn-avatar
              :avatar="dialog?.uploadedAvatar ?? avatar"
              :firstname="firstname"
              :lastname="lastname"
              size="2xl"
              class="rounded-full"
            />

            <div class="absolute right-0 bottom-0 bg-white border border-black border-opacity-100 rounded-full flex h-8 w-8 items-center justify-center group-hover:!bg-black group-hover:!text-white">
              <Icon
                icon="material-symbols:edit-outline-rounded"
                class="h-4 w-4"
              />
            </div>
          </div>
        </div>
      </template>
    </svn-dialog-import-profile-photo>

    <svn-avatar
      v-else
      :avatar="dialog?.uploadedAvatar ?? avatar"
      :firstname="firstname"
      :lastname="lastname"
      size="2xl"
      class="rounded-full"
    />

    <div class="flex flex-col sm:py-2 justify-between !w-full overflow-hidden !gap-[10px] grow">
      <div class="flex flex-col text-left">
        <p class="text-xl font-medium leading-[23px]">{{ firstname }} {{ lastname }} </p>

        <p class="text-sm text-middle-grey font-medium  leading-[17px]">{{ email }}</p>
      </div>

      <div
        class="flex gap-2 flex-wrap sm:flex-nowrap w-full"
        ref="tagsGroup"
      >
        <template
          v-for="(tag, index) in shrinkedTags"
          :key="index"
        >
          <svn-chip
            :text="tag"
          />
        </template>
      </div>
    </div>
  </div>

  <div v-else-if="appVariant === 'studio'" class="w-fit">
    <div class="flex py-4 pl-4 sm:!p-0 gap-3 sm:gap-2 items-center sm:flex-col">
      <div>
        <svn-dialog-import-profile-photo
          v-if="edit"
          ref="dialog"
          @upload-file="uploadFile"
        >
          <template #activator>
            <div class="flex justify-center items-center">
              <div class="group cursor-pointer relative">
                <svn-avatar
                  :avatar="dialog?.uploadedAvatar ?? avatar"
                  :firstname="firstname"
                  :lastname="lastname"
                  :size="avatarSize"
                  class="rounded-full"
                />

                <div class="absolute right-0 bottom-0 bg-white border !border-fakeBlack border-opacity-100 rounded-full flex h-6 w-6 items-center justify-center group-hover:!bg-black group-hover:!text-white">
                  <Icon
                    icon="material-symbols:edit-outline-rounded"
                    class="h-4 w-4"
                  />
                </div>
              </div>
            </div>
          </template>
        </svn-dialog-import-profile-photo>

        <svn-avatar
          v-else
          :avatar="dialog?.uploadedAvatar ?? avatar"
          :firstname="firstname"
          :lastname="lastname"
          :size="avatarSize"
          class="rounded-full"
        />
      </div>

      <div class="flex flex-col sm:py-2 overflow-hidden">
        <div class="flex flex-col sm:gap-4">
          <p class="text-base sm:text-xl text-fake-black font-semibold leading-6">{{ firstname }} {{ lastname }}</p>

          <div class="flex flex-col sm:gap-2">
            <p class="text-sm sm:text-base text-dark-grey sm:text-fake-black font-medium leading-5">{{ email }}</p>

            <p class="text-sm sm:text-base text-dark-grey sm:text-fake-black font-medium leading-5">{{ role }}</p>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>

import SvnAvatar from "@/components/avatar/SvnAvatar.vue";
import {Icon} from "@iconify/vue";
import SvnChip from "@/components/chip/SvnChip.vue";
import {onMounted, ref, watch} from "vue";
import SvnDialogImportProfilePhoto from "@/components/dialog/SvnDialogImportProfilePhoto.vue";

const props = defineProps({
  firstname: {
    type: String,
    default: ''
  },
  lastname: {
    type: String,
    default: '',
  },
  email: {
    type: String,
    default: ''
  },
  tags: {
    type: Array,
    default: () => []
  },
  appVariant: {
    type: String,
    default: 'aleph' // 'aleph' or 'studio'
  },
  role: {
    type: String,
    default: ''
  },
  avatarSize: {
    type: String,
    default: 'xl'
  },
  avatar: {
    type: String,
    default: null
  },
  edit: {
    type: Boolean,
    default: false
  },
  dialogCustomClass: {
    type: String,
    default: 'w-[400px]'
  }
})
const emit = defineEmits(['uploadFile', 'deletePicture'])

const dialog = ref(null)

const tagsGroup = ref(null)
const parentWidth = ref(0)
const tagsGroupWitdh = ref(0)
const windowWidth = ref(0)
const shrinkedTags = ref([])
let tagsGroupResizeObserver

onMounted(() => {
  /**
   *  https://developer.mozilla.org/en-US/docs/Web/API/ResizeObserver
   *  Check the size of the div update and get his width
   */
  if (props.appVariant === "aleph") {
    tagsGroupResizeObserver = new ResizeObserver(entries => {
      for (let entry of entries) {
        tagsGroupWitdh.value = entry.contentRect.width;
        windowWidth.value = window.innerWidth
      }
    });
    if (tagsGroup.value) {
      tagsGroupResizeObserver.observe(tagsGroup.value);
    }
    parentWidth.value = windowWidth.value > 640 ? tagsGroup.value.offsetWidth : tagsGroup.value.offsetWidth * 1.15
  }
})

watch(tagsGroupWitdh, () => {
  if (props.appVariant === "aleph") {
    parentWidth.value = windowWidth.value > 640 ? tagsGroup.value.offsetWidth : tagsGroup.value.offsetWidth * 1.15
    shrinkTags()
  }
})

const shrinkTags = () => {
  let tagsWidth = 0
  let lastTag = false
  shrinkedTags.value = []

  props.tags.forEach((tag, index) => {
    if (!lastTag) {
      if (parentWidth.value > tagsWidth + tag?.length * 9) {
        tagsWidth += tag?.length * 9
        shrinkedTags.value.push(tag)
      } else {
        shrinkedTags.value.push(`+ ${props.tags.length - index}`)
        lastTag = true
      }
    }
  })
}

const uploadFile = (file) => {
  emit('uploadFile', file)
}

const deletePicture = () => {
  dialog.value.uploadedAvatar = null
  emit('deletePicture')
}
</script>
